<?php
/*
 * setup.php (Setup and Configuration script)
 * This file is part of Entrans
 *
 * Copyright (C) 2005 Khader Abbeb N
 * Copyright (C) 2005 R.Vigneswaran 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, 
 * Boston, MA 02111-1307, USA. 
 *
 */



/*		Setup and Configuration Script
 *
 *	This script should be the first script run when setting up the application or when the administrator of the site
 * wishes to re-configure the application.
 *
 *	Functions of this script
 *	========================
 * 1. Create the required tables in the database after geting the required details from the user
 * 2. Create a configuration file for the application so that it uses the newly created tables. 
 *    Note: The 'conf' directory should have "world-writable" permission or *nix permission as 777 during setup so
 *	    that the web server can create the configuration file in that directory.
 *	    The permission of the 'conf' directory should be restored or set to 775 after setup in complete
 * 3. Create an Administrator account for the application
 *
 *										Author: Khader Abbeb N
 */


include ("../include/header_info.php");

?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">

<html>
<head>
<meta http-equiv="Content-Type" content="text/html;charset=utf-8">
<meta name="robots" content="index,follow">
<title>Setup and Install</title>
<script language="javascript" type="text/javascript">
<!--
	function goBack()
	{
		window.location="setup.php";
	}
    function checkDetails()
    {
        var dbname,dbuser;
        db_name = document.setup_form.db_name.value;
        db_user = document.setup_form.db_user.value;
        server_name = document.setup_form.server_name.value;
        if(db_name == "" || db_user == "" || server_name == "") {
          alert("Please fill all the warning fields!");
          return false;
        }
        else
          return true;
    }
<?php
    if($_POST["confirm_setup"])
    {
?>
	function checkAdmin()	// Validation of Administrator Creation form
	{

		var uname, passwd,passwd_confirm;
		uname	= document.admin_form.uname.value;
		passwd	= document.admin_form.passwd.value;
		passwd_confirm = document.admin_form.passwd_confirm.value;
		if (uname=="" || passwd=="" || passwd_confirm=="")
		{
			window.alert("Please enter details for all fields");
                        document.admin_form.uname.focus();
			return false;
		}
		if(passwd.length<6)
		{
			window.alert("Password must have a minimum of 6 characters");
			document.admin_form.passwd.value="";
		    	document.admin_form.passwd_confirm.value="";
                        document.admin_form.passwd.focus();
			return false;
		}
		if(passwd != passwd_confirm)
		{
		    	window.alert("Passwords are not same");
		    	document.admin_form.passwd.value="";
		    	document.admin_form.passwd_confirm.value="";
                        document.admin_form.passwd.focus();
		    	return false;
		}
		return true;
	}
<?php
    }
?>
// -->
</script>

<link rel="stylesheet" type="text/css" charset="utf-8" media="all" href="../css/common.css">
<link rel="stylesheet" type="text/css" charset="utf-8" media="screen" href="../css/screen.css">
</head>

<body  lang="en" dir="ltr"> 
<div id="header">

    <br /><center>	<b>Setup and Installation Page </b> </center>
    <ul id="navibar">
<?php
    if($_POST["sub_db"])
    {
        echo "<li class=\"wikilink\">Database Details</li>";
        echo "<li class=\"current\">Confirmation</li>";
        echo "<li class=\"wikilink\"><a href=\"setup.php\">Back</a></li>";
    }
    else if ($_POST["confirm_setup"])
    {
        echo "<li class=\"wikilink\">Database Details</li>";
        echo "<li class=\"wikilink\">Confirmation</li>";
        echo "<li class=\"current\">Create Administrator</li>";
        echo "<li class=\"wikilink\"><a href=\"setup.php\">Back</a></li>";
    }
    else if ($_POST["sub_admin"])
    {
        echo "<li class=\"wikilink\">Database Details</li>";
        echo "<li class=\"wikilink\">Confirmation</li>";
        echo "<li class=\"wikilink\">Create Administrator</li>";
        echo "<li class=\"current\">Setup Complete</li>";
    }
    else
    {
        echo "<li class=\"current\"><a href=\"setup.php\">Database Details</a></li>";
    }
?>
    </ul>

<div id="pageline"><hr style="display:none;"></div>
</div>
<div id="page">

<?php

    $db_name		= $_POST["db_name"];
    $db_user		= $_POST["db_user"];
    $db_password	= $_POST["db_password"];
    $server_name	= $_POST["server_name"];
    $table_prefix	= $_POST["table_prefix"];
    $file_name    	= "database.conf.php";

    if($_POST["sub_admin"] && $_SESSION['install_session'])
    {

        $uname			= $_POST["uname"];
        $passwd			= md5($_POST["passwd"]);
        $table_user_details	= $table_prefix ."_user_details";

        $db		= @mysql_connect("$server_name","$db_user","$db_password") 
            or die("<b>Error:</b> Cannot connect to MySql server -".mysql_error());
        $db_selected	= mysql_select_db("$db_name",$db) 
            or die ("<b>Error:</b> Unable to use selected Database -".mysql_error());

        $sql_admin	= "insert into $table_user_details (user_name, password, role)".
            "values ('$uname','$passwd','administrator')";
        mysql_query($sql_admin) 
            or die("<b>Error:</b> Unable to create user -".mysql_error()."<br />");
        mysql_close();

        echo "<div style=\"text-align:center\"><b>Adminstrator created successfully</b></div><br />";
        echo "<b> &nbsp;&nbsp;&nbsp;&nbsp;Adminstrator Duties </b>";
        echo "<ul><li>Upload into the server the PO file</li>".
            "<li>Update the database with the contents of the file</li>".
            "<li>Update the file with the validated suggestion</li>".
            "<li>Download the file when required task is accomplished</li>".
            "<li>Manage Validators</li>".
            "</ul>";


        echo "<br /><br /><div class=\"warn\">".
            "<b>IMPORTANT: </b>".
            "<ul><li> Remove the 'WRITE' permission for 'OTHER' users for the '<b>conf</b>' directory.".
            " If not any user having an unix account in the server can manually edit the configuration file ".
            "(database.conf.php)</li>".
            "</ul></div><br />"; 
        echo "<div class=\"start\">".
            "<a id=\"startapp\" href=\"../main.php\">Start Application</a> ".
            "</div>\n" .
            "<script type=\"text/javascript\">\ndocument.getElementById('startapp').focus();\n</script>";

        $_SESSION = array();
        session_destroy();
    }
    else if($_POST["confirm_setup"] && $_SESSION['install_session'])
    {	// Start Database creation on confirmation

        $table_user_details = $table_prefix ."_user_details";
        $table_string_list  = $table_prefix ."_string_list";
        $table_string_context   = $table_prefix ."_string_context";
        $table_suggestion   = $table_prefix ."_string_suggestion";
        $table_poheader     = $table_prefix . "_poheader";
        $table_file_details = $table_prefix ."_file_details";
        $table_lang_details = $table_prefix ."_lang_details";

        $db		= @mysql_connect("$server_name","$db_user","$db_password") 
            or die("<b>Error:</b> Cannot connect to MySql server -".mysql_error());
        $db_selected	= mysql_select_db("$db_name",$db) 
            or die ("<b>Error:</b> Unable to use selected Database -".mysql_error());

        // Create Database Tables
        $create_db    =	"create table $table_user_details ".
            "( user_name varchar(255) primary key, password varchar(255), role varchar(255), ".
            "mail_id varchar(255), recv_mail tinyint(1)  ) ";
        mysql_query($create_db) 
            or die("<b>Error:</b> Unable to create table in database -".mysql_error()."<br />");


        $create_db    =	"create table $table_string_list ".
            "(string_id int(10) primary key, string_value text , ".
            "plural_string_id int(10) default -1, fulltext (string_value))";
        mysql_query($create_db) 
            or die("<b>Error:</b> Unable to create table in database -".mysql_error()."<br />");


        $create_db    =	"create table $table_string_context ".
            "(context_id int(10) primary key, string_id int(10), context text, ".
            "file_id int(10), valid_sug_id int(10) default -1, ".
            "is_plural tinyint(1) default 0, is_fuzzy tinyint(1) default 0)";
        mysql_query($create_db) 
            or die("<b>Error:</b> Unable to create table in database -".mysql_error()."<br />");


        $create_db    =	"create table $table_suggestion ".
            "( sug_id int(10) auto_increment, string_id int(10) not null, user_suggestion blob,".
            "vote int(5) default 1, lang varchar(255), comments text, is_fuzzy tinyint(1), ".
            "primary key(sug_id))";
        mysql_query($create_db) 
            or die("<b>Error:</b> Unable to create table in database -".mysql_error()."<br />");

        $insert_db    = "insert into $table_suggestion values(-1,0,NULL,0,NULL,NULL,0)";
        mysql_query($insert_db) 
            or die("<b>Error:</b> Unable to initialize user suggestion table. ".
            "Insert value into database failed -".mysql_error()."<br />");


        $create_db    =	"create table $table_poheader (file_id int(10) primary key,poheader text)";
        mysql_query($create_db) 
            or die("<b>Error:</b> Unable to create table in database -".mysql_error()."<br />");


        $create_db    =	"create table $table_file_details ".
            "(node_id int(10) auto_increment, node_name varchar(255), ".
            "parent_id int(10), is_po tinyint(1), lang varchar(255), primary key(node_id))";
        mysql_query($create_db) 
            or die("<b>Error:</b> Unable to create table in database -".mysql_error()."<br />");

        $create_db    =	"create table $table_lang_details (code varchar(255) primary key, " .
                        "language varchar(255))";
        mysql_query($create_db) 
        or die("<b>Error:</b> Unable to create table in database -".mysql_error()."<br />");

        $insert_db    =	"insert into $table_lang_details (code, language) values " .
                        "('as','Assamese'),('bn','Bengali'),('gu','Gujarati'),('hi','Hindi')," .
                        "('kn','Kannada'),('ml','Malayalam'),('mr','Marathi'),('ne','Nepali'),".
                        "('or','Oriya'),('pa','Punjabi'),('ta','Tamil'),('te','Telugu')";
        mysql_query($insert_db) 
        or die("<b>Error:</b> Unable to initialize language details. ".
               "Insert value into database failed -".mysql_error()."<br />");

        $insert_db    =	"insert into $table_file_details values(1,'top',-1,0,NULL)";
        mysql_query($insert_db) 
            or die("<b>Error:</b> Unable to initialize file hierarchy. ".
            "Insert value into database failed -".mysql_error()."<br />");

        mysql_close();

        echo "<center><h3>Database was succesfully created </h3></center><br />";

        // Creating Configuration File

        $data =	"<?php \n".
                '$server_name'."\t= \"$server_name\";\t// Server Name or IP \n".
                '$db_name'."\t\t= \"$db_name\";\t// Database Name \n".
                '$db_user'."\t\t= \"$db_user\";\t// Database Username \n".
                '$db_password'."\t= \"$db_password\";\t// Password for the Database User \n\n".
                '$table_user_details'."\t= \"$table_user_details\";\t// Table containing user details \n".
                '$table_string_list'."\t= \"$table_string_list\";\t// Table containing list of input strings \n".
                '$table_string_context'."\t= \"$table_string_context\";".
                                "\t// Table containing string's contexts & valid translation \n".
                '$table_suggestion'."\t= \"$table_suggestion\";\t// Table containing all user suggestions \n".
                '$table_poheader'."\t\t= \"$table_poheader\";\t// Table containing po file header information \n".
                '$table_lang_details'."\t= \"$table_lang_details\";\t// Table containing language details \n".
                '$table_file_details'."\t= \"$table_file_details\";\t// Table containing file hierarchy \n\n".
                '$dir'."\t\t\t= \"uploads/\";\t// Temporary upload directory \n".
                "// Set the uploads directory's permission as 777 for *nix systems\n\n".
                '$log_file'."\t\t= \"logs/updatedb_log\";\t// log file\n".
                '$pid_file'."\t\t= \"logs/pid_file\";\t// contains process ids\n".
                "// Set the logs directory's permission as 777 for *nix systems\n\n".
                '$error_msg'."\t\t= \"\";\t// error message\n".
                "?>";



        if (!$file_handle = fopen($file_name,"w"))
        {
            echo "<br /><b>Error:</b> Unable to create file.<br>";
        }
        if (!$write = @fwrite($file_handle,$data))
        {
            echo "<br /><b>Error:</b> Unable to write into configuration file.<br> ";
        }

        if($file_handle)
            fclose($file_handle);


        // Create Administrator
?>
    <form name="admin_form" method="POST" action="" onSubmit="return checkAdmin();">
    <table align="center" width="50%">
        <thead>
        <tr>
        <td align="center" colspan="2"><b>Create Administrator Account</b></td>
        </tr>
        </thead>
        <tbody>	
        <tr><td colspan="2">&nbsp;</td></tr>
        <tr>
        <td align="left">Login Name </td>
        <td align="center"><input type="text" name="uname" value=""></td>
        </tr>
        <tr><td colspan=2>&nbsp;</td></tr>
        <tr>
        <td align="left">Password </td>
        <td align="center"><input type="password" name="passwd" value=""></td>
        </tr>
        <tr><td colspan="2" align="center">&nbsp;</td></tr>
        <tr>
        <td align="left">Confirm Password</td>
        <td align="center"><input type="password" name="passwd_confirm"</td>
        </tr>
        <tr>
        <td colspan=2>&nbsp;
            <input type="hidden" name="db_name" value="<?php echo $db_name; ?>">
            <input type="hidden" name="db_user" value="<?php echo $db_user; ?>">
            <input type="hidden" name="db_password" value="<?php echo $db_password; ?>">
            <input type="hidden" name="server_name" value="<?php echo $server_name; ?>">
            <input type="hidden" name="table_prefix" value="<?php echo $table_prefix; ?>">
        </td>
        </tr>
        <tr>
        <td align="center" colspan=2><input type="submit" name="sub_admin" value="Submit"></td>
        </tr>
        </tbody>
    </table>
    </form>
        <script type="text/javascript">
        <!--
            document.admin_form.uname.focus();  //setting initial focus
        //-->
        </script>


<?php
    }
    else if($_POST["sub_db"] && $_SESSION['install_session'] )
    {		// Request Confirmation Database details
?>

        <form name="confirm_setup_form" method="POST" action="">
        <table align="center" class="tdborder" cellpadding=3 width="50%">
            <tr class="tdbottom">
            <td colspan=2 align="center"><b>MySQL Database Details</b></td>
            </tr>
            <tr class="tdbottom">
            <td colspan=2  align="center">Confirm your Database details</td>
            </tr>
            <tr >
            <td >&nbsp;</td>
            <td class="tdleft">&nbsp;</td>
            </tr>
            <tr>
            <td width="50%">Database Name</td>
            <td width="50%" class="tdleft"><?php echo $db_name; ?>
                <input type="hidden" name="db_name" value="<?php echo $db_name; ?>"></td>
            </tr>
            <tr>
            <td >&nbsp;</td>
            <td class="tdleft">&nbsp;</td>
            </tr>
            <tr>
            <td>Database Username</td>
            <td class="tdleft"><?php echo $db_user; ?>
                <input type="hidden" name="db_user" value="<?php echo $db_user;?>"></td>
            </tr>
            <tr>
            <td >&nbsp;</td>
            <td class="tdleft">&nbsp;</td>
            </tr>
            <tr>
            <td>Database Password</td>
            <td class="tdleft"><i>Not shown for security reasons</i>
                <input type="hidden" name="db_password" value="<?php echo $db_password; ?>"></td>
            </tr>
            <tr>
            <td >&nbsp;</td>
            <td class="tdleft">&nbsp;</td>
            </tr>
            <tr>
            <td>Database Hostname</td>
            <td class="tdleft"><?php echo $server_name ?>
                <input type="hidden" name="server_name" value="<?php echo $server_name; ?>"></td>
            </tr>
            <tr>
            <td >&nbsp;</td>
            <td class="tdleft">&nbsp;</td>
            </tr>
            <tr>
            <td>Table Prefix</td>
            <td class="tdleft"><?php echo $table_prefix; ?>
                <input type="hidden" name="table_prefix" value="<?php echo $table_prefix; ?>"></td>
            </tr>
            <tr>
            <td >&nbsp;</td>
            <td class="tdleft">&nbsp;</td>
            </tr>
            <tr>
            <td valign="top">Tables to be created</td>
            <td class="tdleft"><?php  echo $table_prefix."_user_details<br />". 
            $table_prefix."_string_list<br />".
            $table_prefix."_string_context<br />".
            $table_prefix."_string_suggestion<br />".
            $table_prefix."_poheader<br />".
            $table_prefix."_file_details<br />".
            $table_prefix."_lang_details<br />";
            ?>
            </tr>
            <tr>
            <td >&nbsp;</td>
            <td class="tdleft">&nbsp;</td>
            </tr>
            <tr class="tdfoot">
            <td>&nbsp;</td>
            <td align="right"><input type="button" name="cancel" value="Cancel" onClick="goBack();">
                      &nbsp;&nbsp;&nbsp;&nbsp;
                      <input type="submit" name="confirm_setup" value="Confirm"></td>
            </tr>
        </table>
        </form>    
        <script type="text/javascript">
        <!--
            document.confirm_setup_form.confirm_setup.focus();  //setting initial focus
        //-->
        </script>
<?php
    }
    else if(! file_exists($file_name))
    {

        if (is_writable('.'))
        {
            $_SESSION['install_session'] = "active";
?>
            <table class="tdborder" align="center" border=0 cellpadding=3 width="50%">
                <tr>
                <td style="padding:10px">To <b>Upgrade</b> from an older version of Entrans click here </td>
                <td>
                    <ul class="buttonbar">
                        <li class="buttonlink"><a href="upgrade.php">Upgrade</a></li>
                    </ul>
                </td>
                </tr>
            </table><br/>
            <form name="setup_form" method="POST" action="">
            <table align="center" border=0 cellpadding=3 width="50%">
                <tr>
                <td colspan=2 align="center"><b>MySQL Database Setup</b></td>
                </tr>
                <tr>
                <td colspan=2 align="center"><span class="warning"> * Mandatory fields</span></td>
                </tr>
                <tr>
                <td colspan=2 align="center">Please enter your Database details</td>
                </tr>
                <tr>
                <td colspan=2>&nbsp;</td>
                </tr>
                <tr>
                <td>Database Name<span class="warning"> * </span></td>
                <td><input type="text" name="db_name" value=""></td>
                </tr>
                <tr>
                <td colspan=2>&nbsp;</td>
                </tr>
                <tr>
                <td>Database Username<span class="warning"> * </span></td>
                <td><input type="text" name="db_user" value=""></td>
                </tr>
                <tr>
                <td colspan=2>&nbsp;</td>
                </tr>
                <tr>
                <td>Database Password</td>
                <td><input type="password" name="db_password" value=""></td>
                </tr>
                <tr>
                <td colspan=2>&nbsp;</td>
                </tr>
                <tr>
                <td>Database Hostname<span class="warning"> * </span></td>
                <td><input type="text" name="server_name" value=""></td>
                </tr>
                <tr>
                <td colspan=2>&nbsp;</td>
                </tr>
                <tr>
                <td colspan=2 >&nbsp;&nbsp;&nbsp;&nbsp;
                    Please enter a unique prefix for the Tables to be created by <b><i>Entrans</i></b>
                    application in your database. <b>Example:</b> tam_01, hindi4, etc.</td>
                </tr>
                <tr>
                <td colspan=2>&nbsp;</td>
                </tr>
                <tr>
                <td>Table Prefix</td>
                <td><input type="text" name="table_prefix" value=""></td>
                </tr>
                <tr>
                <td colspan=2>&nbsp;</td>
                </tr>
                <tr>
                <td colspan=2 align="center"><input type="submit" name="sub_db" 
                    value="Submit" onClick="return checkDetails();"></td>
                </tr>
            </table>
            </form>   
            <script type="text/javascript">
            <!--
                document.setup_form.db_name.focus();  //setting initial focus
            //-->
            </script>
<?php
        }
        else
        {
?>
            <div class="warn">
            <table cellpadding=5>
            <tr>
                <td valign="top"><b>Error:</b></td>
                <td><b><i>Entrans</i></b> does not have the privileges to create a configuration file in the "conf"
                directory inside the Entrans directory. Please set <b><i>write</i></b> permission for 
                <b><i>other</i></b> users for the "conf" directory or make it world-writable 
                (*nix permission 777).
                </td>
            </tr>
            </table>
            <div>

<?php	} 
    }
    else
    {
?>
        <div class="warn">
        <table cellpadding=5 >
            <tr>
            <td valign="top"><b>Error:</b></td><td> The Configuration file "<i><?php echo $file_name; ?></i>" 
            already exists.<br>
            If you wish to change your configuration, you can either edit the existing configuration file or
            you can delete the file and run the Setup once again.
            </td>
            </tr>
        </table>
        </div>
        <div style="padding:10px">
            <table class="tdborder" align="center" border=0 cellpadding=3 width="50%">
                <tr>
                <td style="padding:10px">To <b>Upgrade</b> to a newer version of Entrans click here </td>
                <td>
                    <ul class="buttonbar">
                        <li class="buttonlink"><a href="upgrade.php">Upgrade</a></li>
                    </ul>
                </td>
                </tr>
            </table><br/>
        </div>
        <div class="start">
             <a id="startapp" href="../main.php">Start Application</a>
        </div>
            <script type="text/javascript">
            document.getElementById("startapp").focus();
            </script>
<?php
    }
	
?>
</div>
</body>
</html>
