<?php
/*
 * upgrade.php (Script for upgrading from an older vesion of Entrans)
 * This file is part of Entrans
 *
 * Copyright (C) 2005 Khader Abbeb N
 * Copyright (C) 2005 R.Vigneswaran 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, 
 * Boston, MA 02111-1307, USA. 
 *
 */



include ("../include/header_info.php");
$upgrade	    = $_POST["upgrade"];
$config_file    = "database.conf.php";

function dbTableExists($table_name, $database)
{
    if (!$table_name)
	    return 0;
    $sql_table		= "show tables from $database like '$table_name'";
    $result_table	= mysql_query($sql_table);
    if(mysql_num_rows($result_table) == 1)
	    return 1;
    else
	    return 0;
}

if($upgrade)
{
    $db_name			    = $_POST["db_name"];
    $db_user			    = $_POST["db_user"];
    $db_password		    = $_POST["db_password"];
    $server_name            = $_POST["server_name"];
    $table_user_details		= $_POST["tab_user_details"];
    $table_poheader		    = $_POST["tab_poheader"];
    $table_string_list		= $_POST["tab_string_list"];
    $table_string_context	= $_POST["tab_string_context"];
    $table_suggestion		= $_POST["tab_suggestion"];
    $table_file_details		= $_POST["tab_file_details"];
    $table_lang_details		= $_POST["tab_lang_details"];
    $lang			        = $_POST["lang"];
    $lang_value			    = $_POST["lang_value"];
    
    $lang_details = array(
                            array('as','Assamese'),
                            array('bn','Bengali'),
                            array('gu','Gujarati'),
                            array('hi','Hindi'),
                            array('kn','Kannada'),
                            array('ml','Malayalam'),
                            array('mr','Marathi'),
                            array('ne','Nepali'),
                            array('or','Oriya'),
                            array('pa','Punjabi'),
                            array('ta','Tamil'),
                            array('te','Telugu')
	                    );
}
else
{
    if (file_exists($config_file))
    {
        @include ("$config_file");		// Database config file of older version, if available
    }

    $prefix		= '[prefix]';
    if ($table_poheader)
    {
        $len		= strlen($table_poheader);
        $prefix_len	= $len - 9; // Length of "_poheader" is 9
        $prefix		= substr($table_poheader,0,$prefix_len);
    }

    $table_user_details		= ($table_user_details)   ? $table_user_details   : "[prefix]_user_details";
    $table_poheader		    = ($table_poheader)       ? $table_poheader       : "[prefix]_poheader";
    $table_string_list		= ($table_string_list)    ? $table_string_list    : "[prefix]_string_list";
    $table_string_context	= ($table_string_context) ? $table_string_context : "[prefix]_string_context";
    $table_suggestion		= ($table_suggestion)     ? $table_suggestion     : "[prefix]_string_suggestion";

    $table_file_details		= $prefix . "_file_details";
    $table_lang_details		= $prefix . "_lang_details";
}
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">

<html>
<head>
<meta http-equiv="Content-Type" content="text/html;charset=utf-8">
<meta name="robots" content="index,follow">
<title>Upgrade</title>
<link rel="stylesheet" type="text/css" charset="utf-8" media="all" href="../css/common.css">
<link rel="stylesheet" type="text/css" charset="utf-8" media="screen" href="../css/screen.css">
<script type="text/javascript" src="../scripts/upgrade.js"> </script>
<style type="text/css">
#sub_title {
	font-weight: bold;
}
td {
	padding: 5px;	
}
.tdl10 {
	padding-left: 30px;
}
.yes {
	color: green;
}
.no {
	color: red;
	font-weight: bold;
}
.buttonbar li{
    float: center;
}
.codebox{
    background-color: #E0E0E0;
    border: 1px solid #5A5A5A;
    padding-left: 10px;
    height: 250px;
    overflow: auto;
}
.warning {
    padding-bottom: 10px;
}
</style>

</head>

<body  lang="en" dir="ltr"> 
<div id="header">

    <br /><center>	<b>Upgrade Entrans </b> </center>
    <ul id="navibar">
	<li class="current"><a href="upgrade.php">Upgrade</a></li>
    </ul>

<div id="pageline"><hr style="display:none;"></div>
</div>
<div id="page">
<?php
if ($upgrade)
{
?>
    <table width="70%" class="tdborder" cellpadding="3" align="center" border=0>
	<tr >
	    <td align="left" id="sub_title" width="70%"> Connecting to the Database</td>
	    <td align="left" id="progress_bar" width="30%">
	    <?php
		if ($db_conn = @mysql_connect($server_name, $db_user, $db_password))
		    echo '<span class="yes">Successful</span>';
		else
		{
            echo '<span class="no" >Failed</span>';
            echo '</td></tr></table>';
            echo '<div class="start"><a href="upgrade.php" id="startapp">Back</a></div>';
		    exit;
		}
	    ?>
	    </td>
	</tr>
        <tr >
            <td class="tdl10">Database exists</td>
            <td><?php 
		if (@mysql_select_db($db_name, $db_conn))
		    echo '<span class="yes">Yes</span>';
		else
		{
		    echo '<span class="no" >No</span>';
            echo '</td></tr></table>';
            echo '<div class="start"><a href="upgrade.php" id="startapp">Back</a></div>';
		    exit;
		}

		?>
	    </td>
        </tr>
	<tr class="tdtop">
	    <td align="left" colspan="2" id="sub_title"> Check if Database Tables exists</td>
	</tr>
        <tr>
            <td class="tdl10">User Details Table</td>
            <td>
	    <?php 
		if ($t1 = dbTableExists ($table_user_details, $db_name))
		    echo '<span class="yes">Yes</span>';
		else
		{
		    echo '<span class="no" >No</span>';
		}
	    ?>
	    </td>
        </tr>
        <tr>
            <td class="tdl10">PO Header Table</td>
            <td>
	    <?php 
		if ($t2 = dbTableExists ($table_poheader, $db_name))
		    echo '<span class="yes">Yes</span>';
		else
		{
		    echo '<span class="no" >No</span>';
		}
	    ?>
	    </td>
        </tr>
        <tr>
            <td class="tdl10">String List Table</td>
            <td>
	    <?php 
		if ($t3 = dbTableExists ($table_string_list, $db_name))
		    echo '<span class="yes">Yes</span>';
		else
		{
		    echo '<span class="no" >No</span>';
		}
	    ?>
	    </td>
        </tr>
        <tr>
            <td class="tdl10">String Context Table</td>
            <td>
	    <?php 
		if ($t4 = dbTableExists ($table_string_context, $db_name))
		    echo '<span class="yes">Yes</span>';
		else
		{
		    echo '<span class="no" >No</span>';
		}
	    ?>
	    </td>
        </tr>
        <tr class="tdbottom" >
            <td class="tdl10">Suggestion Table</td>
            <td>
	    <?php 
		if ($t5 = dbTableExists ($table_suggestion, $db_name))
		    echo '<span class="yes">Yes</span>';
		else
		{
		    echo '<span class="no" >No</span>';
		}
	    ?>
	    </td>
        </tr>
	<?php 
        if (!($t1 && $t2 && $t3 && $t4 && $t5))
        {
            echo '</table>';
            echo '<div class="start"><a href="upgrade.php" id="startapp">Back</a></div>';
            exit;
        }
	?>
	<tr class="tdtop">
	    <td align="left" colspan="2" id="sub_title"> Creating New Tables</td>
	</tr>
    <tr>
        <td class="tdl10">File Details Table</td>
        <td>
        <?php
        if (dbTableExists($table_file_details, $db_name))
        {
            echo '<span class="no">Already Exists</span>';
            echo '</td></tr></table>';
            echo '<div class="start"><a href="upgrade.php" id="startapp">Back</a></div>';
            exit;
        }
        else
        {
            $sql_file_table = "create table $table_file_details ".
		        	          "(node_id int(10) auto_increment, node_name varchar(255), ".
			                  "parent_id int(10), is_po tinyint(1), lang varchar(255), primary key(node_id))";
            if(mysql_query($sql_file_table))
		        echo '<span class="yes">Yes</span>';
		    else
		    {
                echo '<span class="no" >No</span>';
                echo '</td></tr></table>';
                echo '<div class="start"><a href="upgrade.php" id="startapp">Back</a></div>';
                exit;
            }
        }
        ?>
        </td>
    </tr>
    <tr>
        <td class="tdl10">Language Details Table</td>
        <td>
        <?php
        if (dbTableExists($table_lang_details, $db_name))
        {
            echo '<span class="no">Already Exists</span>';
            echo '</td></tr></table>';
            echo '<div class="start"><a href="upgrade.php" id="startapp">Back</a></div>';
            exit;
        }
        else
        {
            $sql_lang_table = "create table $table_lang_details ".
			                  "(code varchar(255) primary key, language varchar(255))";
            if(mysql_query($sql_lang_table))
		        echo '<span class="yes">Yes</span>';
		    else
		    {
                echo '<span class="no" >No</span>';
                echo '</td></tr></table>';
                echo '<div class="start"><a href="upgrade.php" id="startapp">Back</a></div>';
                exit;
		    }
        }
        ?>
        </td>
    </tr>
	<tr class="tdtop">
	    <td align="left" colspan="2" id="sub_title"> Upgrading Entrans</td>
    </tr>
    <tr>
        <td colspan="2">
        <div class="codebox">
<?php
        $error  = 0;

        // Modify User Details table
        $sql_modify_user_table  = "alter table $table_user_details ".
                                  "modify column role varchar(255)";
        if (mysql_query($sql_modify_user_table))
            echo "User Details table modified...";
        else
        {
            // $error  = 1;     // As this failure may not cause any problem in the furure
            echo "Unable to modify User Details table. Problem: Minor, can be ignored";
        }

        // Modify String List table
        $sql_modify_list_table  = "alter table $table_string_list ".
                                  "change input_string string_value text";
        if (mysql_query($sql_modify_list_table))
            echo "<br>String List table modified...";
        else
        {
            $error  = 1;
            echo "<br>Unable to modify String List table.";
        }
        
        // Insert top-most branch in file hierarchy
        $sql_init_file_table    = "insert into $table_file_details ".
                                  "(node_id, node_name, parent_id, is_po, lang) values ".
                                  "(1, 'top', -1, 0, NULL)";
        if (mysql_query($sql_init_file_table))
            echo "<br>File Details table initialized...";
        else
        {
            $error  = 1;
            echo "<br>Unable to intialize File Details table.";
        }

        // Update Language Details table
        $partial_query = "";
        foreach ($lang_details as $lang_detail)
        {
            if ($lang == $lang_detail[0]) {
                continue;
            }
            $partial_query .= ($partial_query) ? "," : "";
            $partial_query .= "('" . $lang_detail[0] . "','" . $lang_detail[1] . "')";
        }
        $partial_query .= ",('$lang','$lang_value')";
        
        $sql_lang_data  = "insert into $table_lang_details (code, language) values ".
                          $partial_query;
        if (mysql_query($sql_lang_data)) {
            echo "<br>Language Details table updated...";
        }
        else
        {
            $error  = 1;
            echo "<br>Unable to update Language Details table.";
        }
        
        // Add new columns for String Context table
        $sql_context_table      = "alter table $table_string_context ".
                                  "add column file_id int (10) after file_name, ".
                                  "add column is_plural tinyint(1) default 0, ".
                                  "add column is_fuzzy tinyint(1) default 0, ".
                                  "alter column valid_sug_id set default -1";
        
        if ($result_context_table   = mysql_query($sql_context_table))
            echo "<br>String Context table partially altered...";
        else
        {
            $error  = 1;
            echo "<br>Unable to alter String Context table.";
        }

        // Get all distinct file names
        $sql_file_names         = "select distinct file_name from $table_poheader";
        $result_file_names      = mysql_query($sql_file_names);
        if ($num_files  = mysql_num_rows($result_file_names))
        {
            $file_names             = array();
            $file_id                = 2;
            $file_node_details      = "";
            while ($row_file_names  = mysql_fetch_row($result_file_names))
            {
                $file_names[$file_id]   = $row_file_names[0];
                $file_name              = $row_file_names[0];
                $file_node_details      = $file_node_details . "($file_id, '$file_name', 1, 1, '$lang'),";
                $file_id++;
            }
            $file_node_details      = trim($file_node_details);
            $file_node_details      = substr($file_node_details, 0, -1);

            // Insert file details into File Details table
            $sql_ins_file_details   = "insert into $table_file_details ".
                                      "(node_id, node_name, parent_id, is_po, lang) values $file_node_details";
            if (mysql_query($sql_ins_file_details))
                echo "<br>File Details table populated...";
            else
            {
                $error  = 1;
                echo "<br>Unable to populate File Details table.";
            }

            // Update String Context table with file ids
            echo "<br>Updating String Context table...";
            $error_file_switch  = 0;
            for ($file_id=2; $file_id <= ($num_files+1); $file_id++)
            {
                $file_name                  = $file_names[$file_id];
                $sql_update_context_table   = "update $table_string_context ".
                                              "set file_id = $file_id where file_name = '$file_name'";
                if (!mysql_query($sql_update_context_table))
                {
                    $error_file_switch  = 1;
                    $error              = 1;
                    echo "<br> - Unable modify details for file: $file_name.";
                }
            }
            if (!$error_file_switch)
            {
                echo "<br> - File Id values updated...";

            }
        }
        
        if (!$num_files || !$error_file_switch)
        {
            // Remove File Name column
            $sql_remove_col = "alter table $table_string_context drop file_name";
            if (mysql_query($sql_remove_col))
            {
                echo "<br> - <i>File Name</i> column removed...".
                     "<br>String Context table fully altered";
            }
            else
            {
            //    $error  = 1; 
                echo "<br> - Unable to remove <i>File Name</i> column. Problem: Minor, can be ignored.";
            }
        }
        
/*
        // Set Fuzzy values
        $sql_set_fuzzy      = "update $table_string_context set is_fuzzy=0";
        if (mysql_query($sql_set_fuzzy))
            echo "<br> - Fuzzy values updated...";
        else
        {
            $error  = 1;
            echo "<br> - Unable to set Fuzzy values.";
        }
 */
        // Get all plural string id
        $sql_plural_string_ids      = "select plural_string_id from $table_string_list ".
                                      "where plural_string_id != -1";
        $result_plural_string_ids   = mysql_query($sql_plural_string_ids);
        if (mysql_num_rows($result_plural_string_ids))
        {
            $plural_ids     = array();
            while ($row_plural_string_ids = mysql_fetch_row($result_plural_string_ids))
            {
                $plural_ids[]   = $row_plural_string_ids[0];
            }
            $plural_condition   = "string_id = ". implode(" OR string_id = ", $plural_ids);

            // Updating Is_Plural value
            $sql_update_plural  = "update $table_string_context ".
                                  "set is_plural=1 where $plural_condition";
            if (mysql_query($sql_update_plural))
                echo "<br> - Is Plural values updated...";
            else
            {
                $error  = 1;
                echo "<br> - Unable to update Is Plural values.";
            }
        }

        // Update Valid Suggestion Id
        $sql_update_valid_sug_id    = "update $table_string_context ".
                                      "set valid_sug_id=-1 ".
                                      "where valid_sug_id=0 OR valid_sug_id is NULL";
        if (mysql_query($sql_update_valid_sug_id))
            echo "<br> - Valid suggestion Ids updated...";
        else
        {
            $error  = 1;
            echo "<br> - Uanble to update Valid Suggestion Ids.";
        }

        // Modifying String Suggestion Table
        $sql_sug_table  = "alter table $table_suggestion ".
                          "modify column lang varchar(255)";
        if (mysql_query($sql_sug_table))
            echo "<br>Suggestion table modified...";
        else
        {
            // $error  = 1;     // Minor Problem. Will not create any problems.
            echo "<br>Unable to alter Suggestion table. Problem: Minor, can be ignored";
        }

        // Adding Is fuzzy column for String Suggestion Table
        $sql_sug_table  = "alter table $table_suggestion ".
                          "add column is_fuzzy tinyint(1) default 0";
        if (mysql_query($sql_sug_table))
            echo "<br>Suggestion table altered...";
        else
        {
            $error  = 1;
            echo "<br>Unable to alter Suggestion table.";
        }

        // Update String Suggestion table with lang details
        $sql_update_sug = "update $table_suggestion ".
                          "set lang='$lang'";
        if (mysql_query($sql_update_sug))
            echo "Suggestion table updated...";
        else
        {
            $error  = 1;
            echo "Unable to update language details in Suggestion table";
        }

        // Add a new entry to String Suggestion table
        $sql_update_sug = "insert into $table_suggestion ".
                          "values(-1, 0, NULL, 0, NULL, NULL, 0);";
        if (mysql_query($sql_update_sug))
            echo "Suggestion table updated...";
        else
        {
            $error  = 1;
            echo "Unable to add new entry to Suggestion table";
        }

/*
        // Updating Is Fuzzy value of Suggestion table
        $sql_fuzzy_val  = "update $table_suggestion set is_fuzzy=0";
        if (mysql_query($sql_fuzzy_val))
            echo "<br>Suggestion table updated...";
        else
        {
            $error  = 1;
            echo "<br> Unable to update Suggestion table.";
        }
 */
        // Alter PO header table
        $sql_header = "alter table $table_poheader ".
                      "add column file_id int(10) FIRST";
        if (mysql_query($sql_header))
            echo "<br>PO Header table partially altered...";
        else
        {
            $error = 1;
            echo "<br>Unable to alter PO Header table.";
        }

        // Update PO Header table
        for ($file_id=2; $file_id <= ($num_files+1); $file_id++)
        {
            $file_name          = $file_names[$file_id];
            $sql_update_header  = "update $table_poheader ".
                                  "set file_id = $file_id where file_name = '$file_name'";
            if (!mysql_query($sql_update_header))
            {
                $error_update_header = 1;
            }
        }
        if (!$error_update_header)
            echo "<br>PO Header table updated...";
        else
        {
            $error  = 1;
            echo "<br>Unable to update PO Header table.";
        }

        // Remove File Name column
        $sql_remove_col = "alter table $table_poheader drop file_name";
        if (mysql_query($sql_remove_col))
            echo "<br>PO Header table fully altered";
        else
        {
            // $error  = 1;
            echo "<br>Unable to alter PO Header table. Problem: Minor, can be ignored. ";
        }

        
?>
        </div>
        </td>
    </tr>
<?php
        if ($error)
        {
            echo '<tr><td colspan="2" class="no"> Upgradation is only partially complete. '.
                 'See above messages for details';
            echo '</td></tr>';
        }
        else
        {
        	echo '<tr >';
            echo '    <td align="left" >Upgradation of Database tables</td>';
            echo '    <td class="yes">Done</td>';
            echo '</tr>';
        }

    	$data =	"<?php \n".
	        	'$server_name'.     "\t\t\t= \"$server_name\";\t\t// Server Name or IP \n".
        		'$db_name'.       "\t\t\t\t= \"$db_name\";\t\t// Database Name \n".
        		'$db_user'.       "\t\t\t\t= \"$db_user\";\t\t// Database Username \n".
        		'$db_password'.     "\t\t\t= \"$db_password\";\t\t // Password for the Database User, \n".
        		'$table_user_details'."\t\t= \"$table_user_details\"; // Table containing user details \n".
        		'$table_string_list'. "\t\t= \"$table_string_list\"; // Table containing list of input strings \n".
        		'$table_string_context'."\t= \"$table_string_context\";".
		        				" // Table containing string's contexts & valid translation\n".
        		'$table_suggestion'.  "\t\t= \"$table_suggestion\"; // Table containing all user suggestions \n".
        		'$table_poheader'.  "\t\t\t= \"$table_poheader\"; // Table containing po file header information \n".
        		'$table_file_details'."\t\t= \"$table_file_details\"; // Table containing file hierarchy \n".
        		'$table_lang_details'."\t\t= \"$table_lang_details\"; // Table containing language list \n".
        		'$dir'.         "\t\t\t\t\t= \"uploads/\"; // Temporary upload directory \n".
        		"\t// Set the uploads directory's permission as 777 for *nix systems\n\n".
                '$log_file'.      "\t\t\t\t= \"logs/updatedb_log\"; //log file\n".
                '$error_msg'.     "\t\t\t\t= \"\"; //error message\n".
        		"?>";


    	$data_no_passwd = "<?php \n".
                        '$server_name'.     "\t\t\t= \"$server_name\";\t\t// Server Name or IP \n".
                        '$db_name'.       "\t\t\t\t= \"$db_name\";\t\t// Database Name \n".
                        '$db_user'.       "\t\t\t\t= \"$db_user\";\t\t// Database Username \n".
                        '$db_password'.     "\t\t\t= \"ENTER_PASSWORD\";\t\t // Password for the Database User, \n".
                        '$table_user_details'."\t\t= \"$table_user_details\"; // Table containing user details \n".
                        '$table_string_list'. "\t\t= \"$table_string_list\"; // Table containing list of input strings \n".
                        '$table_string_context'."\t= \"$table_string_context\";".
                                        " // Table containing string's contexts & valid translation\n".
                        '$table_suggestion'.  "\t\t= \"$table_suggestion\"; // Table containing all user suggestions \n".
                        '$table_poheader'.  "\t\t\t= \"$table_poheader\"; // Table containing po file header information \n".
                        '$table_file_details'."\t\t= \"$table_file_details\"; // Table containing file hierarchy \n".
                        '$table_lang_details'."\t\t= \"$table_lang_details\"; // Table containing language list \n".
                        '$dir'.         "\t\t\t\t\t= \"uploads/\"; // Temporary upload directory \n".
                        "\t// Set the uploads directory's permission as 777 for *nix systems\n\n".
                        '$log_file'.      "\t\t\t\t= \"logs/updatedb_log\"; //log file\n".
                        '$error_msg'.     "\t\t\t\t= \"\"; //error message\n".
                        "?>";


       	if (!$file_handle = @fopen($config_file,"w"))
        {
            $error_file     = 1;
            $error_msg_file = "<b>Error:</b> Unable to create configuration file. ".
                              "Check permissions of configuration file and its parent directory";
        }
        if (!$write = @fwrite($file_handle,$data))
        {
            $error_file     = 1; 
            $error_msf_file = "<b>Error:</b> Unable to write into configuration file.";
        }

        if($file_handle)
            fclose($file_handle);


?>
        <tr class="tdtop">
            <td id="sub_title">Creating new configuration file</td>
            <?php
            if (!$error_file)
                echo '<td class="yes">Done</td>';
            else
            {
                echo '<td class="no">Failed</td>';
                echo '<tr><td colspan="2" class="warning">';
                echo $error_msg_file;
                echo '</td></tr>';
                echo '<tr><td colspan="2">';
                echo 'Please copy the following details into the configuration file '.
                     '(<i>conf/database.conf.php</i>). Please ensure that there are no white-spaces or '.
                     'newline characters before the PHP start tag (&lt;?php) and after the PHP end tag'.
                     '(?&gt;)';
                echo '<pre class="codebox">';
                echo htmlentities($data_no_passwd);
                echo '</pre>';
                echo '</td></tr>';
            }
            ?>
                
    </table>
<?php
        if ($error)
        {
            echo '<div class="start"><a href="upgrade.php" id="startapp">Back</a></div>';
        }
        else
        {
            echo '<div class="start"><a href="../main.php" id="startapp">Start Application</a></div>';
        }
}
else
{

    if (file_exists($config_file))
    {
        if (!is_writable($config_file))
        {
            echo '<div class="warning">';
            echo '<b>Warning:</b> Database configuration file (<i>conf/database.conf.php</i>) is not writable by '.
                'web server. You can change its write-access permission now or '.
                'follow the instructions given in the next page.';
            echo '</div>';
        }
    }
    else if (!is_writable('.'))
    {
        echo '<div class="warning">';
        echo '<b>Warning:</b> Entrans/Webserver does not have sufficient permission to create configuration file '.
            'under <b>conf/</b> directory. You can change the permission of <b>conf</b> directory to world-writable now '.
            'or follow the instructions given in the next page';
        echo '</div>';
    }

?>
    <form name="upgrade_form" method="POST" action="" onSubmit="return checkUgradeForm();">
    <table width="70%" class="tdborder" cellpadding="3" align="center" border=0>
	<tr class="tdbottom">
	    <td align="left" width="60%" id="sub_title"> Select the type of upgrade</td>
	    <td align="right" width="40%" class="warning">All fields except password are mandatory </td>
	</tr>
	<tr>
	    <td colspan="2" style="padding:5px;padding-left:30px;padding-bottom:15px;" class="tdbottom" valign="top">
		<input type="radio" name="upgrade_02_03" value="yes" checked> Upgrade from Entrans v0.2 to Entrans v0.3 or later
	    </td>
	</tr>
	<tr class="tdbottom">
	    <td align="left" colspan="2" id="sub_title"> Database Details</td>
	</tr>

        <tr>
            <td>Database Name </td>
            <td><input type="text" name="db_name" value=""></td>
        </tr>
        <tr>
            <td>Database Username </td>
            <td><input type="text" name="db_user" value=""></td>
        </tr>
        <tr>
            <td>Database Password</td>
            <td><input type="password" name="db_password" value=""></td>
        </tr>
        <tr class="tdbottom">
            <td>Database Hostname</td>
            <td><input type="text" name="server_name" value=""></td>
        </tr>
	<tr class="tdbottom">
        <td align="left" colspan="2"><b>Existing Database Tables</b> 
        <span >(<i>See the configuration file for details</i>)</span>
        </td>
	</tr>
        <tr>
            <td>User Details Table</td>
            <td><input  class="db_details" type="input" name="tab_user_details" 
			value=<?php echo "\"$table_user_details\""; ?>></td>
        </tr>
        <tr>
            <td>PO Header Table</td>
            <td><input  class="db_details" type="input" name="tab_poheader" 
			value=<?php echo "\"$table_poheader\""; ?>></td>
        </tr>
        <tr>
            <td>String List Table</td>
            <td><input  class="db_details" type="input" name="tab_string_list" 
			value=<?php echo "\"$table_string_list\""; ?>></td>
        </tr>
        <tr>
            <td>String Context Table</td>
            <td><input  class="db_details" type="input" name="tab_string_context" 
			value=<?php echo "\"$table_string_context\""; ?>></td>
        </tr>
        <tr class="tdbottom" >
            <td>Suggestion Table</td>
            <td><input  class="db_details" type="input" name="tab_suggestion" 
			value=<?php echo "\"$table_suggestion\""; ?>></td>
        </tr>
	<tr class="tdbottom">
	    <td align="left" colspan=2 id="sub_title"> Additional Database Tables Required</td>
	</tr>
        <tr>
            <td>File Details Table</td>
            <td><input  class="db_details" type="input" name="tab_file_details" 
			value=<?php echo "\"$table_file_details\" "; ?>></td>
        </tr>
        <tr class="tdbottom">
            <td >Language Details Table</td>
            <td><input  class="db_details" type="input" name="tab_lang_details" 
			value=<?php echo "\"$table_lang_details\" "; ?>></td>
        </tr>
	<tr class="tdbottom">
	    <td align="left" colspan=2 id="sub_title"> Please enter the following details</td>
	</tr>
        <tr >
            <td >Language of PO files in the older version (0.2)</td>
            <td><input class="db_details" type="input" name="lang_value" value=""></td>
        </tr>
        <tr class="tdbottom">
            <td >Language Code (Eg., 'ta', 'hi', 'bn', etc)</td>
            <td><input class="db_details" type="input" name="lang" value=""></td>
        </tr>
        <tr>
            <td colspan="2" style="padding: 5px 30px" class="warning">
                <b>Warning:</b> Upgradation process is not reversible. Please take a backup of your 
                database and your database configuration file (<i>conf/database.conf.php</i>). 
                Also, double check the data you have entered in the above form.
            </td>
        </tr>
        <tr class="tdbottom">
	    <td> Are you sure you want to upgrade?</td>
	    <td> <input type="submit"  name="upgrade" value="Upgrade"></td>
	</tr>
    </table>
    </form>
<?php
}
?>
</div>
</body>
</html>
