<?php
/*
 * functions_dbadminister.php
 * This file is part of Entrans
 *
 * Copyright (C) 2005 Khader Abbeb N
 * Copyright (C) 2005 R.Vigneswaran 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, 
 * Boston, MA 02111-1307, USA. 
 *
 */

/*
 * This page contains supporting functions for dbadminister.php
 *
 *                                                        Author: R.Vigneswaran
 */

include ("functions_organize_dbadminister.php");

//////////////////////////// fn_update_db --> starts here //////////////////////////

function fn_update_db($file_id, $path, $lang)
{
    //extracts the informations from po file and put it into the database

    //table names have been defined in database.conf.php file
    global $table_string_list, $table_string_context, $table_suggestion;
    global $table_poheader, $error_msg;
  
    if (!$file_id)
    {
        $error_msg = "Error: No file is selected.";
        return false;
    }
    $file_name = getNodeName($file_id);
    if (!$file_name)
    {
        $error_msg = "Error: Invalid file id.";
        return false;
    }
    if (substr($path, -1) != "/")
        $path .= "/";
        
    $file_type           = "unknown";
    $file_ptr_state      = "transition"; //state variable, contains the current state
    $string_value        = "";           //string to be translated
    $context             = "";           //context of the string
    $trans_comments      = "";           //translator comment
    $current_translation = "";           //current translation
    $string_value_plural = "";           //plural string
    $current_translation_plural = "";    //translation for plural string
    $poheader            = "";           //po file header
    $is_fuzzy            = 0;

    $src_file        = $path . $file_name;
    $src_file_handle = @fopen("$src_file", "r");      //open the file for reading
    if (!$src_file_handle)
    {
        $error_msg = "Error: Unable to open file '$src_file'. Check the permissions!";
        return false;
    }
  
    $input_line = "***";
    while (!feof($src_file_handle) && trim($input_line) != "")
    {
    //search for the first empty line, to read the header
        $input_line = fgets($src_file_handle);
        $poheader  .= $input_line;
    }
  
    //getting the last string id, context id, suggestion id from database
  
    $sql_result = mysql_query("select max(string_id) from $table_string_list");

    if (!$sql_result)
    {
        $error_msg = "Error#1: " . mysql_error();
        return false;
    }

    //mysql_result function's return value is a string
    //intval function returns 0 if its argument is an empty string
    
    if ($string_id = intval(mysql_result($sql_result, 0, 0)))
    {
        $string_id++;
    }
    else {
        $string_id = 1;
    }
  
    $sql_result = mysql_query("select max(context_id) from $table_string_context");

    if (!$sql_result)
    {
        $error_msg = "Error#2: " . mysql_error();
        return false;
    }
                        
    if ($context_id = intval(mysql_result($sql_result, 0, 0)))
    {
        $context_id++;
    }
    else {
        $context_id = 1;
    }
  
    $sql_result = mysql_query("select max(sug_id) from $table_suggestion");

    if (!$sql_result)
    {
        $error_msg = "Error#3: " . mysql_error();
        return false;
    }
        
    if ($sug_id = intval(mysql_result($sql_result, 0, 0)))
    {
        if ($sug_id != -1)
        {                    //don't add this condition to the outer if statement
            $sug_id++;       //otherwise the type and value of the variable $sug_id will change
        }
        else {
            $sug_id = 1;
        }
    }
    else {
        $sug_id = 1;
    }
    
    while (!feof($src_file_handle))
    {
    //until end of file reached for selected file
            
        $input_line = trim(fgets($src_file_handle));
        $input_tok  = strtok($input_line, " ");

        if (substr($input_tok, 0, 1) == "#" &&
           ($file_ptr_state == "transition" || $file_ptr_state == "context"))
        {
        //current line is a context
           
            $file_ptr_state = "context";
            $comment_type = $input_tok;
            
            if ($comment_type == "#")
            {
            //the context is a translator message
                if ($trans_comments)
                {
                    $trans_comments .= "\n";
                }
                $trans_comments .= trim(substr($input_line, 2));
            }
            else if ($comment_type == "#," && strpos($input_line, "fuzzy") !== false)
            {
                $is_fuzzy = 1;
                if (trim($input_line) != "#, fuzzy")
                {
                    $elements     = explode(",", $input_line);
                    $elements_len = count($elements);
                    for ($index = 1; $index < $elements_len; $index++)
                    {
                        if ($elements[$index] == " fuzzy")
                        {
                            array_splice($elements, $index, 1);
                            break;
                        }
                    }
                    $context .= implode(",", $elements);
                }
            }
            else
            {
                $context .= $input_line;
            }
        }
        
        if (($file_ptr_state == "context" || $file_ptr_state == "transition")
           && $input_tok == "msgid")
        //occurrence of word 'msgid'
            $file_ptr_state="input_str";
            
        if ($file_ptr_state == "input_str" && $input_tok == "msgid_plural")
            $file_ptr_state = "input_str_plural";
            
        if (($file_ptr_state == "input_str" && $input_tok == "msgstr") ||
           ($file_ptr_state == "input_str_plural" && $input_tok == "msgstr[0]"))
        {
            $file_ptr_state = "current_translation";
            $file_type      = "po";
            //the given file is in .po format
        }
        
        if ($file_ptr_state == "current_translation" && $input_tok == "msgstr[1]")
            $file_ptr_state = "current_translation_plural";

        if (($file_ptr_state == "current_translation" ||
            $file_ptr_state == "current_translation_plural") && $input_line == "")
        {
            //a complete entry found. now insert the tables with extracted values
                   
            //addslashes will escape the special characters by adding back slashes
            $context             = addslashes($context);
            $string_value        = addslashes($string_value);
            $current_translation = addslashes($current_translation);
            $trans_comments      = addslashes($trans_comments);
            
            if ($string_value_plural != "")
            {
            //plural string exists in the po file
                $string_value_plural        = addslashes($string_value_plural);
                $current_translation_plural = addslashes($current_translation_plural);
            }

            //check whether the message string is already in 
            //the database, if so get string_id

            $select_query = "select string_id, string_value from $table_string_list " .
                            "where string_value='$string_value'";
            $sql_result = mysql_query($select_query);

            if (!$sql_result)
            {
                $error_msg = "Error#4: " . mysql_error();
                return false;
            }
            
            $temp_string_id = "";
            while ($row = mysql_fetch_row($sql_result))
            {
            //since query is not case sensitive, more than one rows can be returned
                
                if ($string_value == addslashes($row[1]))
                {
                //message string is already present in the database

                    $temp_string_id = $string_id;
                    //preserve the current string_id for continuity
                    
                    $string_id = $row[0];
                    //new string id

                    break;
                }
            }

            $temp_plural_string_id = "";
            $plural_string_id      = -1;
            if ($string_value_plural != "")
            {
                //check whether the message string plural is already in 
                //the database, if so get string_id

                $select_query = "select string_id, string_value from $table_string_list " .
                                "where string_value='$string_value_plural'";
                $sql_result = mysql_query($select_query);

                if (!$sql_result)
                {
                    $error_msg = "Error#5: " . mysql_error();
                    return false;
                }
  
                while ($row = mysql_fetch_row($sql_result))
                {
                //since query is not case sensitive, more than one rows can be returned
             
                    if ($string_value_plural == addslashes($row[1]))
                    {
                        //message string plural is already present in the database
                        $temp_plural_string_id = $row[0];
                        break;
                    }
                }
            }
            else
            {
                $temp_plural_string_id = -1;
            }

            if ($temp_string_id == "")
            {
                //message string does not exist in the database
               
                $insert_query_plural = "";

                if ($temp_plural_string_id == -1)
                {
                    //no plural for this message string is available in the po file

                    $plural_string_id = -1;
                } 
                else if ($temp_plural_string_id == "")
                {
                    //plural for this message string available in the po file, but
                    //does not exist in the database

                    $plural_string_id    = $string_id + 1;

                    $insert_query_plural = "insert into $table_string_list " .
                                    "(string_id, string_value, plural_string_id) values" .
                                    "($plural_string_id, '$string_value_plural', -1)";
                }
                else
                {
                    //plural for this message string available in the po file, and
                    //exists in the database

                    $plural_string_id = $temp_plural_string_id;
                }
                $insert_query = "insert into $table_string_list " .
                                "(string_id, string_value, plural_string_id) values".
                                "($string_id, '$string_value', $plural_string_id)";
                $sql_result = mysql_query($insert_query);

                if (!$sql_result)
                {
                    $error_msg = "Error#6: " . mysql_error();
                    return false;
                }

                if ($insert_query_plural != "")
                {
                    $sql_result = mysql_query($insert_query_plural);

                    if (!$sql_result)
                    {
                        $error_msg = "Error#7: " . mysql_error();
                        return false;
                    }
            
                    unset($insert_query_plural);
                }

            }//message string does not exist in the database ends here

            else
            {
                //message string exits in the database

                $insert_query_plural = "";
                $update_query        = "";

                if ($temp_plural_string_id == -1)
                {
                    //no plural for this message string is available in the po file

                    $plural_string_id = -1;
                } 
                else if ($temp_plural_string_id == "")
                {
                    //plural for this message string available in the po file, but
                    //does not exist in the database

                    $plural_string_id = $temp_string_id;
                    $temp_string_id++;

                    $insert_query_plural = "insert into $table_string_list " .
                                    "(string_id, string_value, plural_string_id) values" .
                                    "($plural_string_id, '$string_value_plural', -1)";
                    $update_query = "update $table_string_list set plural_string_id=" .
                                    "$plural_string_id where string_id=$string_id";
                }
                else
                {
                    //plural for this message string available in the po file, and
                    //exists in the database

                    $plural_string_id = $temp_plural_string_id;
                    $update_query = "update $table_string_list set plural_string_id=" .
                                    "$plural_string_id where string_id=$string_id";
                }
                if ($insert_query_plural != "")
                {
                    $sql_result = mysql_query($insert_query_plural);

                    if (!$sql_result)
                    {
                        $error_msg = "Error#8: " . mysql_error();
                        return false;
                    }
                }
                if ($update_query != "")
                {
                    $sql_result = mysql_query($update_query);

                    if (!$sql_result)
                    {
                        $error_msg = "Error#9: " . mysql_error();
                        return false;
                    }
                }

            }//message string exits in the database ends here

            //now message string and plural string (if any) are available in the database 
            //(may be already exist or inserted by the previous steps)

            $first_iter = true;

            do
            {
                if ($current_translation != "")
                {
                    //valid translation available in the po file
                
                    $select_query = "select sug_id, vote from $table_suggestion where".
                                    " string_id='$string_id' and " .
                                    "user_suggestion='$current_translation' and lang='$lang'" .
                                    " and lang!=''";
                    $sql_result = mysql_query($select_query);

                    if (!$sql_result)
                    {
                        $error_msg = "Error#10: " . mysql_error();
                        return false;
                    }
                                        
                    if ($row = mysql_fetch_row($sql_result))
                    {
                        //valid translation exists in the database
                        
                        $suggestion_id = $row[0];
                        $vote          = $row[1];
                        $vote++;                    //increase the vote by one

                        $update_query = "update $table_suggestion set vote=$vote, comments=" .
                                        "'$trans_comments', is_fuzzy=$is_fuzzy where " .
                                        "sug_id=$suggestion_id";
                        $sql_result = mysql_query($update_query);

                        if (!$sql_result)
                        {
                            $error_msg = "Error#11: " . mysql_error();
                            return false;
                        }
                    }
                    else
                    {      
                    //valid translation does not exist in the database
                    
                        $suggestion_id = $sug_id;
                        $insert_query = "insert into $table_suggestion (sug_id, string_id, " .
                                        "user_suggestion, lang, comments, is_fuzzy) values" .
                                        "($suggestion_id, $string_id, '$current_translation', " .
                                        "'$lang', '$trans_comments', $is_fuzzy)";
                        $sql_result = mysql_query($insert_query);

                        if (!$sql_result)
                        {
                            $error_msg = "Error#12: " . mysql_error();
                            return false;
                        }
                        $sug_id++;
                    }
                }
                else
                {
                //valid translation does not exist
                    $suggestion_id = -1;
                }
                //in this point we have string_id and suggestion_id

                $select_query = "select context_id, valid_sug_id from " .
                                "$table_string_context where " .
                                "file_id=$file_id and string_id=$string_id" .
                                " and context='$context'";
                $sql_result = mysql_query($select_query);

                if (!$sql_result)
                {
                    $error_msg = "Error#13: " . mysql_error();
                    return false;
                }
          
                if ($row = mysql_fetch_row($sql_result))
                {
                    //context_id available

                    if ($suggestion_id == -1)
                    {
                        $suggestion_id = $row[1];
                    }
                
                    $update_query = "update $table_string_context set " .
                                    "valid_sug_id=$suggestion_id, is_fuzzy=$is_fuzzy " .
                                    "where context_id=$row[0]";
                    $sql_result = mysql_query($update_query);

                    if (!$sql_result)
                    {
                        $error_msg = "Error#14: " . mysql_error();
                        return false;
                    }
                }
                else
                {
                //context_id is not available
               
                    if ($first_iter)
                    {
                        $is_plural = 0;
                    }
                    else
                    {
                        $is_plural = 1;
                    } 
                    $insert_query = "insert into $table_string_context (context_id, " .
                            "string_id, context, file_id, valid_sug_id, is_plural, is_fuzzy)" .
                            " values($context_id, $string_id, '$context', $file_id, " .
                            "$suggestion_id, $is_plural, $is_fuzzy)";
                    $sql_result = mysql_query($insert_query);

                    if (!$sql_result)
                    {
                        $error_msg = "Error#15: " . mysql_error();
                        return false;
                    }
                    $context_id++;
                }
      
                if ($first_iter && $string_value_plural != "")
                {
                    //if plural string available in the po file, 
                    //put an entry for plural translation too

                    if ($temp_string_id == "")
                    {
                        $temp_string_id = $string_id + 1;
                        if ($temp_string_id_plural == "")
                        {
                            $temp_string_id++;
                        }
                    }
                    $string_id = $plural_string_id; //store it to the $string_id variable
                    $current_translation = $current_translation_plural;
                    $first_iter = false;
                }
                else
                {
                    break;
                }
                
            }while (1);

            if ($temp_string_id != "")
            {
            //some string id is preserved
                $string_id = $temp_string_id; //restore it to the $string_id variable
            }
            else 
            {
                $string_id++;               //increase the $string_id variable
            }

            $file_ptr_state = "transition";    //current line is an emptyline
            $context        = "";                     //initialize the variables
            $trans_comments = "";
            $string_value   = "";
            $is_fuzzy       = 0;
            $current_translation = "";
            $string_value_plural = "";
            $current_translation_plural = "";
            
        }//End of code for occurrence of empty line after current translation

        $input_line_part = trim(strstr($input_line, "\""));
        //take the string starting with double quote from current line
        
        if ($file_ptr_state == "input_str")
        {
            //remove the starting and ending double quote
            $string_value .= substr($input_line_part, 1, -1);
        }
        
        //store the extracted string into the appropriate variable
        
        if ($file_ptr_state == "input_str_plural")
        {
            $string_value_plural .= substr($input_line_part, 1, -1);
        }
        
        if ($file_ptr_state == "current_translation")
        {
            $current_translation .= substr($input_line_part, 1, -1);
        }
        
        if ($file_ptr_state == "current_translation_plural")
        {
            $current_translation_plural .= substr($input_line_part, 1, -1);
        }
        
    }//end of while loop (until the occurrence of end of file for the selected file)

    fclose($src_file_handle);
  
    if ($file_type == "po")
    {
    //selected file is a PO file
    
        $poheader = addslashes(trim($poheader));
    
        $select_query = "select file_id from $table_poheader where ".
                        "file_id=$file_id";
        $sql_result = mysql_query($select_query);

        if (!$sql_result)
        {
            $error_msg = "Error#16: " . mysql_error();
            return false;
        }
    
        $insert_query = "insert into $table_poheader (file_id, poheader) " .
                        "values($file_id, '$poheader')";
        if (mysql_fetch_row($sql_result))
        {
            $insert_query = "update $table_poheader set poheader='$poheader' where " .
                            "file_id=$file_id";
        }    
        $sql_result = mysql_query($insert_query);

        if (!$sql_result)
        {
            $error_msg = "Error#17: " . mysql_error();
            return false;
        }
        return true;
        
    }// if file_type == po ends here
    
    else
    {
        $error_msg = "Error: Selected file '$file_name' is not a PO file!";
        return false;
    }
}
//////////////////////////// fn_update_db --> ends here ////////////////////////////


//////////////////////////// fn_upload --> starts here /////////////////////////////

function fn_upload($file_name, $tmp_file_name, $path)
{
    //uploads the file
    global $error_msg;

    $file_name = basename($file_name);
    if (substr($path, -1) != "/")
        $path .= "/";

    if (!is_dir($path) && !mkdirs($path))
    {
        $error_msg = "Error: Path $path doesn't exist.";
        return false;
    }

    $upload_file = $path . $file_name;
    if (!is_uploaded_file($tmp_file_name))
    {
        $error_msg = "Error: Upload failure. File size may exceed the maximum uploadable size.";
        return false;
    }
    if (@move_uploaded_file($tmp_file_name, $upload_file))
    {
        //move uploaded temporary file to a particular directory
        chmod($upload_file, 0666);  //give read, write permission to uploaded file
        return true;
    }
    else 
    {  
        //not able to move uploaded temporary file to a particular directory
        $error_msg = "Error: Not able to move uploaded file to the directory '$path'." .
                     " Check the permissions!";
        return false;
    }
}
/////////////////////////////// fn_upload --> ends here ////////////////////////////


/////////////////////////////// fn_update --> starts here //////////////////////////

function fn_update($file_name, $path, $parent_id, $lang, $background, $recovery_mode)
{
//this function calls a function to parse the uploaded files and update the database

    global $log_file, $error_msg;

    $file_name = basename($file_name);
    if (substr($path, -1) != "/")
        $path .= "/";

    $upload_file = $path . $file_name;
    $user        = $_SESSION['user'];
    $user        = ($user) ? $user : "guest";
    $write_log   = true;
    $userindex   = 5; //index of user name in pid_file entry
    $phpInPath   = isPHPInPath();
    
    $log_file_suffix = "_{$user}_".date('Ymd');
    $log_file .= $log_file_suffix;
    
    $log_msg = "";
    if ($write_log)
    {
        $log_msg = "<a href=\"$log_file\" target=\"_\" class=\"no_uline\">View</a> log file.";
    }

    if ($recovery_mode)
    {
        if (isAnyProcessAlive($user))
        {
        //already recovery is in progress
            $error_msg = "Error: Similar php process is in progress. Please try again later.";
            return false;
        }
        
        $file_list = getFileList($path, "");
        $file_list = str_replace("recovery.list\n", "", $file_list);
        $file_list = trim($file_list);
        if (!$file_list)
        {
            delPIDEntry($userindex, $user);
            $error_msg = "Error: No files present for recovery.";
            return false;
        }

        if (!($out_file_handle = @fopen("$upload_file", "w")))
        {
            $error_msg = "Error: Unable to create file '$upload_file'. Check the permissions.";
            return false;
        }
        fputs($out_file_handle, $file_list);
        fclose($out_file_handle);
        delPIDEntry($userindex, $user);
    }
//    exit($file_list);

    if ($background)
    {
        if (!$phpInPath)
        {
            fn_delete_file($file_name, $path);
            $error_msg = "Error: Can not create background process.<br>".
                   "Please uncheck the 'Run in background' checkbox and try again.";
            return false;
        }
        $msg = "Database updation started in background. $log_msg";
        `php -q updatedb.php $upload_file $parent_id $lang $write_log $user $log_file > /dev/null &`;
    }
    else {
        $msg = fn_process($upload_file, $parent_id, $lang, $write_log, $user, $log_file);
    }

    return $msg;
}
/////////////////////////////// fn_update --> ends here ////////////////////////////


///////////////////////////// fn_process --> starts here ///////////////////////////

function fn_process($upload_file, $parent_id, $lang, $write_log, $user, $log_file)
{
    global $error_msg;

  if (!file_exists($upload_file))
  {
      $error_msg = "Error: Unable to find input file $upload_file.";
      return false;
  }
  if (!$parent_id)
  {
      $error_msg = "Error: No parent id specified.";
      return false;
  }

  $input_file = basename($upload_file);
  $path       = dirname($upload_file);
//  exit("filename $input_file path $path parent_id $parent_id\n");

  $uncompress_list = "";
  $delete_source = true;
  $from_url = false;

  if (ereg("\.tar\.gz$", $input_file) || ereg("\.tgz$", $input_file))
  {
      $uncompress_list = `cd $path; tar -ztf $input_file`;
      $uncompress = `cd $path; tar -zxvf $input_file`;
  }
  else if (ereg("\.tar$", $input_file))
  {
      $uncompress_list = `cd $path; tar -tf $input_file`;
      $uncompress = `cd $path; tar -xvf $input_file`;
  }
  else if (ereg("\.zip$", $input_file))
  {
      $unziplist = `cd $path; unzip -l $input_file`;
      $unziplist_arr = explode("\n", $unziplist);
      $len = count($unziplist_arr);
      for ($index = 3;$index < $len-3;$index++)
      {
          $uncompress_list .= substr($unziplist_arr[$index], strrpos($unziplist_arr[$index], ' ')+1) . "\n";
      }
      $uncompress = `cd $path; unzip -o $input_file`;
  }
  else if (ereg("\.gz$", $input_file))
  {
      $uncompress_list = substr($input_file, 0, strrpos($input_file, ".gz"));
      $uncompress = `cd $path; gunzip $input_file`;
      $delete_source = false;
  }
  else if (ereg("\.tar\.bz2$", $input_file) || ereg("\.tbz2$", $input_file) ||
          ereg("\.tar\.bz$", $input_file) || ereg("\.tbz$", $input_file))
  {
      $uncompress_list = `cd $path; tar -jtf $input_file`;
      $uncompress = `cd $path; tar -jxvf $input_file`;
  }
  else if (ereg("\.bz2$", $input_file) || ereg("\.bz$", $input_file))
  {
      $uncompress_list = substr($input_file, 0, strrpos($input_file, ".bz"));
      $uncompress = `cd $path; bunzip2 $input_file`;
      $delete_source = false;
  }
  else if (ereg("\.url$", $input_file))
  {
  //file containing urls to po files
      $from_url = true;
  }
  else if (ereg("\.list$", $input_file))
  {
  //file containing list of files to be recovered
      $src_fh = @fopen($upload_file, "r");
      while (!feof($src_fh))
      {
          $uncompress_list .= fgets($src_fh);
      }
      fclose($src_fh);
  }
  else
  {
  //normal .po file
      $uncompress_list = $input_file;
      $delete_source = false;
  }

  $dt = date('Y-m-d h:i:s A');

  if ($from_url)
  {
    //gets the contents from the urls specified in the input file

    $file_count = 0;
    
    `echo "$dt input file: $input_file\nreading files from internet ...\n">>$log_file`;

    $input_file_handle = @fopen($upload_file, "r");//open the file for reading

    while (!feof($input_file_handle))
    {
        $url=trim(fgets($input_file_handle));
        if (!$url || substr($url, 0, 1) == "#")
        {    //skip the comment
            continue;
        }
        $file_name = basename($url);
        $upload_file = "$path/$file_name";
        $uncompress_list .= "$file_name\n";
        
        `wget -O $upload_file $url`;
        
        $file_count++;
    }
    fclose($input_file_handle);
    
    $dt = date('Y-m-d h:i:s A');
    
    `echo "$dt input file: $input_file\nno. of files: $file_count\t\treading completed.\n">>$log_file`;

  }

  if ($delete_source)
  {
      fn_delete_file($input_file, $path);
  }
//exit($uncompress_list);

  $file_count = 0;
  $delete_file_list = "";
  $uncompress_list = trim($uncompress_list);
  $uncompress_list_arr = explode("\n", $uncompress_list);
  $len = count($uncompress_list_arr);
  
  for ($index=0;$index<$len;$index++)
  {
      if (substr($uncompress_list_arr[$index], -1) != "/")
      { 
      //if the current entry is not a directory (ie., po file)
      
          $file_count++;
          $file_name  = basename($uncompress_list_arr[$index]);
          $inner_path = dirname($uncompress_list_arr[$index]);
          $full_fname = $uncompress_list_arr[$index];
          if ($write_log)
          {
              `echo "$dt input file: $input_file\nfile: $full_fname\tupdating ...\n">>$log_file`;
          }
          $file_id = insertNode($full_fname, $parent_id, 1, $lang);
          if ($file_id)
          {
              $result = fn_update_db($file_id, "$path/$inner_path", $lang);
              if ($write_log)
              {
                  $dt = date('Y-m-d h:i:s A');
              }
              if ($result)
              {
                  $result_tmp = "\tupdated.";
              }
              else {
//                  removeNode($file_id);
                  $result_tmp = "\t$result";
              }
          }
          else {
              $result_tmp = "\tUnable to get file id.";
          }
          if ($write_log)
          {
              `echo "$dt input file: $input_file\nfile: $full_fname $result_tmp\n">>$log_file`;
          }
          
          fn_delete_file($file_name, "$path/$inner_path");
//          echo "\nfile $file_name path $path/$inner_path";
          
      } //if not directory ends here
      
      else if (dirname($uncompress_list_arr[$index]) == ".")
      {
          $delete_file_list .= $uncompress_list_arr[$index] . " ";
      }
      
  }//for loop ends here
  
//  echo "$delete_file_list\n";

  $delete_file_list = trim($delete_file_list);
  if ($delete_file_list)
  {
      $delete_file_list_arr = explode(" ", $delete_file_list);
      foreach($delete_file_list_arr as $dir_name)
      {
          fn_delete_file($dir_name, $path);
      }
  }

  if ($uncompress_list == $input_file)
  {
      if ($result)
      {
          return "The file $input_file has been updated successfully.";
      }
      else {
          return $result;
      }
  }
  if ($write_log)
  {
      `echo "$dt input file: $input_file\nno. of files: $file_count\t\tupdation completed.\n">>$log_file`;
  }
  
  return "The updation process has been completed for the file $input_file.<br>" .
         "<a href=\"$log_file\" target=\"_\" class=\"no_uline\">View</a> log file.";
}
////////////////////////////// fn_process --> ends here ////////////////////////////


/////////////////////////////// addLang --> starts here ////////////////////////////

function addLang($lang_name, $lang_code)
{
    global $table_lang_details, $error_msg;
    
    $sql_query = "insert into $table_lang_details (code, language) values".
                 "('$lang_code', '$lang_name')";
                  
    if (!$lang_code || !$lang_name)
    {
        $error_msg = "Error: Language code and name can not be empty.";
        return false;
    }
    
    $sql_result = mysql_query($sql_query);

    if (!$sql_result)
    {
        $error_msg = "Error#18: " . mysql_error();
        return false;
    }
    
    return "Language $lang_name has been added successfully.";
}
//////////////////////////////// addLang --> ends here /////////////////////////////


///////////////////////////// removeLang --> starts here ///////////////////////////

function removeLang($lang_code)
{
    global $table_lang_details, $error_msg;
    
    $sql_query = "delete from $table_lang_details where code=".
                 "'$lang_code'";
                  
    if (!$lang_code)
    {
        $error_msg = "Error: Invalid language code.";
        return false;
    }

    if (filesUnderLang($lang_code))
    {
        $error_msg = "Error: Can not remove the language " . getLangName($lang_code) .
                     ", it is being used.";
        return false;
    }
    
    $lang_name  = getLangName($lang_code);
    $sql_result = mysql_query($sql_query);

    if (!$sql_result)
    {
        $error_msg = "Error#19: " . mysql_error();
        return false;
    }
    
    return "Language $lang_name has been deleted successfully.";
}
////////////////////////////// removeLang --> ends here ////////////////////////////


////////////////////////////// fn_uninstall --> starts here ////////////////////////

function fn_uninstall()
{
    //drops all tables and removes the configuration file belongs to this application

    global $table_string_list, $table_string_context, $table_suggestion, $dir;
    global $table_poheader, $table_user_details, $table_file_details, $table_lang_details;
    global $error_msg;
  
    fn_delete_file('*', $dir);
    fn_delete_file('*', 'logs/');
    
    $drop_query = "drop table $table_string_list, $table_string_context, " .
                  "$table_suggestion, $table_user_details, $table_poheader, " .
                  "$table_file_details, $table_lang_details";

    $sql_result = mysql_query($drop_query);

    if (!$sql_result)
    {
        $error_msg = "Error#20: " . mysql_error();
        return false;
    }

    if (!fn_delete_file('database.conf.php', 'conf/'))
    {
        $error_msg = "Error: Cannot delete 'conf/database.conf.php'. ".
                     "Delete the file manually.";
        return false;
    }
    return true;
}
////////////////////////////// fn_uninstall --> ends here //////////////////////////


///////////////////////////// getFileList --> starts here //////////////////////////

function getFileList($path, $inner_path)
{
    $file_list = "";
    
    if (substr($path, -1) != "/")
        $path .= "/";
        
    if ($inner_path && substr($inner_path, -1) != "/")
        $inner_path .= "/";

    if (is_dir($path))
    {
        if ($dh = opendir($path . $inner_path))
        {
            while (($file = readdir($dh)) !== false)
            {
                if ($file != "." && $file != "..")
                {
                    if (is_dir($path . $inner_path . $file))
                    {
                        $file_list .= $inner_path . $file . "/\n";
                        $file_list .= getFileList($path, $inner_path . $file);
                    }
                    else
                    {
                        $file_list .= $inner_path . $file . "\n";
                    }
                }
            }
            closedir($dh);
        }
    }
    return $file_list;
}
/////////////////////////////// getFileList --> ends here //////////////////////////


////////////////////////// isAnyAbnormalTerm --> starts here ///////////////////////

function isAnyAbnormalTerm($user)
{
    $pid_arr = getPIDs($user);

    $ret_val = false;
    if ($pid_arr && !isPHPProcessExist($pid_arr, "and"))
    {
        $ret_val = true;
    }
    
    return $ret_val;
}
/////////////////////////// isAnyAbnormalTerm --> ends here ////////////////////////


////////////////////////// isAnyUploadedFile --> starts here ///////////////////////

function isAnyUploadedFile($path)
{
    $ret_val = false;
    
    if (is_dir($path))
    {
        if ($dh = opendir($path))
        {
            while (($file = readdir($dh)) !== false)
            {
                if ($file == "." || $file == "..")
                {
                    continue;
                }
                $ret_val = true;
                break;
            }
            closedir($dh);
        }
    }    
    return $ret_val;
}
/////////////////////////// isAnyUploadedFile --> ends here ////////////////////////


////////////////////////// isAnyProcessAlive --> starts here ///////////////////////

function isAnyProcessAlive($user)
{
    global $pid_file;
    
    $pid_file_exists = file_exists($pid_file);
    
    $pid_arr = getPIDs($user);

    $ret_val = false;
    if (($pid_arr || !$pid_file_exists) && isPHPProcessExist($pid_arr, "or"))
    {
        $ret_val = true;
    }
    
    return $ret_val;
}
/////////////////////////// isAnyProcessAlive --> ends here ////////////////////////


//////////////////////////////// getPIDs --> starts here ///////////////////////////

function getPIDs($user)
{
    global $pid_file;
  
    $file = $pid_file;
    $userindex = 5; //index, corresponding to the user name in the $pid_file entry
    $pidindex  = 0; //index, corresponding to the process id in the $pid_file entry
    $pid_arr   = array();
  
    if ($src_fh = @fopen($file, "r"))
    {
        while (!feof($src_fh))
        {
            $line = fgets($src_fh);
            $fields = explode(",", $line);
            if ($fields[$userindex] == $user)
            {
                $pid_arr[] = $fields[$pidindex];
            }
        }
        fclose($src_fh);
    }
    return $pid_arr;
}
///////////////////////////////// getPIDs --> ends here ////////////////////////////
  
  
/////////////////////////// getUploadDetails --> starts here ///////////////////////

function getUploadDetails($user)
{
    global $pid_file;
  
    $file = $pid_file;
    $userindex = 5; //index, corresponding to the user name in the $pid_file entry
    $fields = array();
  
    if ($src_fh = @fopen($file, "r"))
    {
        while (!feof($src_fh))
        {
            $line = fgets($src_fh);
            $fields = explode(",", $line);
            if ($fields[$userindex] == $user)
            {
                break;
            }
        }
        fclose($src_fh);
    }
    return $fields;
}
//////////////////////////// getUploadDetails --> ends here ////////////////////////
  
  
/////////////////////////// delPIDEntry() --> starts here //////////////////////////

function delPIDEntry($key, $value)
{
    global $pid_file;
  
    $file = $pid_file;
    $tmp_file = $pid_file . ".tmp";
  
    if ($src_fh = @fopen($file, "r"))
    {
        if ($out_fh = @fopen($tmp_file, "w"))
        {
            while (!feof($src_fh))
            {
                $line = fgets($src_fh);
                $fields = explode(",", $line);
                if ($fields[$key] != $value)
                {
                    fputs($out_fh, $line);
                }
            }
            fclose($out_fh);
        }
        fclose($src_fh);
        @unlink($file);
        @rename($tmp_file, $file);
    }
}
//////////////////////////// delPIDEntry() --> ends here ///////////////////////////
?>
