<?php
/*
 * functions_main.php
 * This file is part of Entrans
 *
 * Copyright (C) 2005 Khader Abbeb N
 * Copyright (C) 2005 R.Vigneswaran 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, 
 * Boston, MA 02111-1307, USA. 
 *
 */

    function insert_stat_table($root)
    {
 	echo '<table width="95%" class="tdborder" align="center" cellpadding=5>';
        echo '    <tr style="font-weight:bold;" class="tdbottom">';
        echo '        <td width="2%" align="center">&nbsp;</td>';
        echo '        <td width="33%" align="left"> Branch/Files </td>';
        echo '        <td width="10%" align="center"> File Options </td>';
        echo '        <td width="7%" align="center"> Total </td>';
        echo '        <td width="10%" align="center"> Translated </td>';
        echo '        <td width="10%" align="center"> Untranslated </td>';
        echo '        <td width="" align="center" colspan=2> Percent Complete </td>';
        echo '    </tr>';

        $option_list = getChild($root);

    	if ($option_list && is_array($option_list))
    	{

        $index = 1;
        
	    foreach ($option_list as $option)
	    {
	    	echo '<tr>';
	    	$node_id	= $option[0];
	    	$node_name	= $option[1];
	    	$is_po		= $option[2];
	    	if (!$is_po)
	    	{
		    $list_po		= getAllSubPO($node_id);
		    $num_strings 	= $num_trans_strings 	= $num_untrans_strings	= 0;
		    $graph_width 	= $percent_complete	= 100;
		    if (!empty($list_po))
		    {
	            	$num_strings		= getNumStringsFileArray($list_po);
		    	$num_untrans_strings	= getNumUntransStringsFileArray($list_po);
		    	$num_trans_strings	= $num_strings - $num_untrans_strings;
		    	$percent_complete = 0;
		    	if($num_strings)
		    	{
                    $percent_complete	= round( ($num_trans_strings/$num_strings)*100,1);
		    	}
		    }

		    echo '<td>&nbsp;</td><td align="left">';
		    echo "    <a href=\"main.php?root=$node_id\">$node_name</a>";
	            echo '</td>';
		    echo '<td align="center"> &nbsp;</td>';
	            echo "<td align=\"center\"> $num_strings </td>";
	            echo "<td align=\"center\"> $num_trans_strings  </td>";
	            echo "<td align=\"center\"> $num_untrans_strings  </td>";
	            echo '<td align="center">'; 
			draw_graph($percent_complete, $graph_width);
		    echo '</td>';
		    echo '<td align="right">';
		    if ($num_strings == 0)
			echo '<i>No Data</i>';
		    else 
			echo $percent_complete .'%';
		    echo '</td>';
	    	}
	        else
	        {
	            $num_strings	= getNumStringsFile($node_id);
		    $num_untrans_strings= getNumUntransStringsFile($node_id);
		    $num_trans_strings	= $num_strings - $num_untrans_strings;
        	    $percent_complete = 0;
		    if($num_strings)
		    {
	                $percent_complete	= round( ($num_trans_strings/$num_strings)*100,1);
        	    }
		    $graph_width 	= 100;

		    echo '<td>'.$index++.'</td><td align="left">';
		    echo '<a href="list.php?file_list=yes&amp;'.
			 "file_id=$node_id&amp;page=1\">$node_name</a><br>";
		    echo '</td>';
		    echo '<td align="center">'; 
		    if ($_SESSION['user_role'] == "validator")
		    {
			echo "<a href=\"edit_poheader.php?selected_file_id=$node_id\">";
			echo '<img title="Edit Header" src="images/edit_head.png" alt="Download"></a>';
			echo '&nbsp;&nbsp;&nbsp;&nbsp;';
		    }
		    echo "<a href=\"download.php?selected_file_id=$node_id\">" .
		         '<img title="Download" src="images/download.png" alt="Download"></a>';
		    echo '</td>';
	            echo "<td align=\"center\"> $num_strings </td>";
	            echo "<td align=\"center\"> $num_trans_strings  </td>";
	            echo "<td align=\"center\"> $num_untrans_strings  </td>";
	            echo '<td align="center">'; 
			draw_graph($percent_complete, $graph_width); 
		    echo '</td>';
		    echo '<td align="right">'. $percent_complete .'%</td>';
	        }
	        echo '</tr>';
	    }
	    echo '</table>';
        }
        else
	    echo '<tr><td colspan="7">No files in this section</td></tr></table>';
    }

    function insert_path($root,$var_name)
    {
	$root_name	= getNodeName($root);
	$path		= array();
	$id_path	= array();
	$id_path	= array_merge (getPathId($root), array($root));
	$path		= array_merge (getPath($root), array($root_name));
	$index		= 0;
	$length		= count ($id_path);
	echo "<p id=\"path\">";
	for ($index = 0; $index < $length; $index++)
	{
	    $node_id	= $id_path[$index];
	    $node_name	= $path[$index];
	    echo "<a href=\"main.php?$var_name=$node_id\">$node_name</a> > ";
	}
	echo "</p>";
    }

    function draw_graph($percent_complete, $graph_width)
    {
	$highlight_width	= round($percent_complete);
	$rem_width		= $graph_width - $highlight_width;

	echo "<table width=\"$graph_width\">";
	echo '<tr>';
	echo "<td width=\"$highlight_width\" height=\"10\" bgcolor=\"#51ff51\">";
	echo '<img src="images/spacer.png" alt=""></td>';
	echo "<td width=\"$rem_width\" height=\"10\" bgcolor=\"#ff2a2a\">";
	echo '<img src="images/spacer.png" alt=""></td>';
	echo '</tr>';
	echo '</table>';
    }

    function insertFileStruct($parent_id)
    {
	global $table_file_details;
	$branch_name	= getNodeName($parent_id);
	echo '<ul class="filebox">';
	echo '<li class="branch">'. 
	     '<a class="no_uline" href="main.php?parent_id='.$parent_id.'">'.$branch_name .'</a></li>';
	echo '</ul>';
        echo '<div class="boxline">';
	$sql_get_child_po	= "select node_id, node_name, is_po from $table_file_details ".
				  "where parent_id = '$parent_id' order by is_po desc, node_name";
	$result_get_child_po	= mysql_query($sql_get_child_po);
	if (mysql_num_rows($result_get_child_po))
	{
	    $index	= 1;
	    echo '<ul class="filelist" >';
	    while ($row_get_child_po	= mysql_fetch_row($result_get_child_po))
	    {
		$node_id	= $row_get_child_po[0];
		$node_name	= $row_get_child_po[1];
		$is_po		= $row_get_child_po[2];
		if ($is_po)
		{
		    echo '<li style="clear:both;">';
		    echo $index . '. <a href="list.php?file_list=yes&amp;'.
			 "file_id=$node_id&amp;page=1\">$node_name</a>";
		    echo '</li>';
		    $index++;
		}
		else
		{
		    insertFileStruct($node_id);
		}
	    }
	    echo '</ul>';
	}
	else
	{
	    echo "<i>(Empty)</i>";
	}
	echo '</div>';
    }

?>
