<?php
/*
 * functions_organize_dbadminister.php
 * This file is part of Entrans
 *
 * Copyright (C) 2005 Khader Abbeb N
 * Copyright (C) 2005 R.Vigneswaran 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, 
 * Boston, MA 02111-1307, USA. 
 *
 */
 
/*  This file contains supporting functions for both organize.php and
 *  dbadminister.php
 *
 *								AUTHOR: Khader Abbeb N, Vigneswaran R
 */

include_once ("functions_stat.php");

function fn_delete_file($file_name,$path)
{
    //deletes the specified file or directory recursively
    global $error_msg;
    
    $delParent = true;

    $file_name = basename($file_name);
    if($file_name == "*") {
        $file_name = "";
        $delParent = false;
    }
    if($path && substr($path,-1) != "/")
        $path .= "/";

    $full_path = $path . $file_name;
    if(!isPathInside($full_path,"./")) {
        return false;
    }
    
    if(is_dir($full_path)) {
        if($dh = opendir($full_path)) {
            while(($file = readdir($dh)) !== false) {
                if($file == "." || $file == "..") {
                    continue;
                }
                fn_delete_file($file,$full_path);
            }
            closedir($dh);
            if($delParent && @rmdir($full_path)) {
                return true;
            }
        }
    }
    else {
        if(@unlink($full_path)) {
            return true;
        }
    }    
    return false;
}

function insertNode($node_name, $parent_id, $is_po, $lang)
{
    global $table_file_details,$error_msg;

    if(!$node_name) {
        $error_msg = "Node name cannot be empty.";
        return false;
    }
    if (strpos($node_name, "/") !== false)
    {
        $path_arr = preg_split('@/@', $node_name, -1, PREG_SPLIT_NO_EMPTY);
        $len = count($path_arr);
        $count = 1;
        $t_is_po = 0;
        $t_lang = '';
        
        foreach ($path_arr as $path_name)
        {
            if ($count == $len) {
                $t_is_po = $is_po;
                $t_lang = $lang;
            }
            $count++;
            $node_id = insertNode($path_name, $parent_id, $t_is_po, $t_lang);
            if ($node_id === false) {
                return false;
            }
            $parent_id = $node_id;
        }
        return $node_id;
    }
    $node_id = getNodeId($node_name,$parent_id);
    if($node_id)
    {
        if($lang) {
            $sql_update_node = "update $table_file_details set lang='$lang' where " .
                    "node_name='$node_name' and parent_id=$parent_id";
            mysql_query ($sql_update_node) or Die ("Database error! " . mysql_error());
        }
        return $node_id;
    }
    else
    {
        $sql_insert_node = "insert into $table_file_details (node_name, parent_id, is_po, lang)" .
                           " values ('$node_name','$parent_id',$is_po,'$lang')";			  	  
        mysql_query ($sql_insert_node) or Die ("Database error! " . mysql_error());
        return getNodeId($node_name,$parent_id);
    }
}

function removeNode($node_id)
{
    global $table_file_details,$error_msg;

    if ($node_id != 1)
    {
        $sql_remove_node = "delete from $table_file_details where ".
                           "node_id = '$node_id'";

        if (isBranchEmpty($node_id))
        {
            mysql_query ($sql_remove_node) or Die ("Database error! " . mysql_error());
            return true;
        }

        $error_msg = "<b>Warning</b> : Only empty branches can be deleted";
        return false;

    }
    $error_msg = "Cannot remove <b>top</b> branch";
    return false;
}

function isPHPInPath()
{
    $result = `php -q php_test.php`;

    $ret_val = ($result == "success") ? true : false;
    
    return $ret_val;
}

function isPHPProcessExist($pid,$relation)
{
    $g_pid = "";
    $pid_count = 0;

    if($pid) {
        $g_pid = "|grep ";
        
        if(is_array($pid)) {
            $pid_count = count($pid);
            $g_pid .= implode("\\|",$pid);
        }
        else {
            $g_pid .= "$pid";
        }
    }
//    echo "expression ps -e|grep php " . $g_pid;
    $result = `ps -e|grep php $g_pid`;
    
    $ret_val = false;
    if($result)
    {
        $ret_val = true;
        
        if($relation == "and") {
            $result = trim($result);
            $result_arr = explode("\n",$result);
            $ret_val = ($pid_count == count($result_arr)) ? true : false;
        }
    }

    return $ret_val;
}

function isPathInside($path,$parent) {
    $path   = realpath($path);
    $parent = realpath($parent);
    $pos = strpos($path,$parent);
    if($path === false || $pos === false || $pos) {
        return false;
    }
    return true;
}

function mkdirs($dir, $mode = 0777, $recursive = true) {
  if( is_null($dir) || $dir === "" ){
   return FALSE;
  }
  if( is_dir($dir) || $dir === "/" ){
   return TRUE;
  }
  if( mkdirs(dirname($dir), $mode, $recursive) ){
   return mkdir($dir, $mode);
  }
  return FALSE;
}
